<?php

// Miscellaneous PHP Functions
// 
// Helpful functions for PHP development
//
// Copyright (C) 2010 Luke Mounsey
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License included in the file 
// "license.txt" for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.


// sanitize
//
// cleans up text submitted via a form
// with various security features
//
// parameters
// unclean - input text
// sql - if true, string will be escaped for mysql
// returns
// clean - sanitized text

function sanitize($unclean,$sql=false){

	$clean=trim(strip_tags($unclean));
	
	if($sql){$clean=mysql_real_escape_query($clean);}
	
	return $clean;

}// end sanitize

// strip extra spaces
//
// removes any extra spaces from text,
// such that there is only 1 space
// between words
//
// parameters
// text - text to be stripped.
// returns 
// text with extra spaces removed

function strip_extra_spaces($text){

	$old=$text;
	$new=str_replace("  "," ",$text);
	
	if($old==$new){return $new;}
	else{return strip_extra_spaces($new);}

}// end strip_extra_spaces

// db_connect
//
// connects to a mysql server,
// and connect to the specified databse
//
// parameters
// host - mysql hostname
// user - mysql username
// pass - mysql password
// db 	- mysql database name 

function db_connect($host,$user,$pass,$db=null){

	mysql_connect($host,$user,$pass);
	
	if($db!==null){
	
		mysql_select_db($db);
	
	}

}// end db_connect

// dropdown_menu
//
// creates a dropdown menu
// does not create the <select> tag
//
// parameters
// labels - the options as DISPLAYED in the list
// options - the options as SUBMITTED via the form
// selected - the option that should be selected

function dropdown_menu($labels,$options,$selected=null){

	$menu="";
	
	if(count($labels)!==count($options)){return null;}
	
	$limit=count($labels);
	
	for($i=0;$i<$limit;$i++){
	
		$menu.="<option value='{$options[$i]}'";
		
		if($options[$i]==$selected){$menu.=" selected='selected' ";}
		
		$menu.=">{$labels[$i]}</option>";
	
	}
	
	return $menu;

}

// element - element name (can be an array)
// value - new element value (can be an array)
// title - hyperlink title
// class - hyperlink stylesheet class

function make_link($element, $value, $title="", $class="", $target=""){

	//echo("lookup $lookup");//||$lookup_submitted||[]");

	if (!is_array($element)){$element=array($element);}
	if (!is_array($value)){$value=array($value);}

	$i=0;

	$link=$_SERVER['PHP_SELF']."?".$_SERVER["QUERY_STRING"];

	$find=array(" ",";");
	$repl=array("+","%3B");

	$ls=str_replace($find,$repl,$lookup_submitted);
	$lp=str_replace($find,$repl,$lookup);

	$link=str_replace($ls, $lp,$link);

	//echo("<br>$link<br>");

	while($ele=$element[$i]){

		$s=strpos($link,"$ele=");
		$start=strpos($link,"=",$s)+1;
		$end=strpos($link,"&",$start);

		if($end===false){$current=substr($link,$start);}
		else{$current=substr($link,$start,$end-$start);}
		if($s===false){$current="";}

		$val=$value[$i];

		//echo("element: $ele| value:$val |current: $current<br>");

		if($current==""){$link.="&$ele=$val";}
		else{$link=str_replace("$ele=$current","$ele=$val",$link);}

		$i+=1;
	
	}// end while

	$link=str_replace("&","&amp;",$link);

	$html="<a href='$link' ";
	
	if($title!=""){$html.="title='$title' ";}
	if($class!=""){$html.="title='$class' ";}
	if($target!=""){$html.="title='$target' ";}
			
	$html.=">";
	
	return $html;		
	
	//return "<a href='$link' title='$title' class='$class' target='$target'>";

}// end makeLink

?>
