<?php

// website search
//
// class for searching database-driven websites
// used with Website SuperSearch
//
// Copywright (C) 2010 Luke Mounsey
//
// See "readme.txt" for installation details
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License included in the file 
// "license.txt" for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

class website_search extends sql_search{

	public $post_vars=array("submit","search_type","exact_words","search_fields","search_query","display_page","orderby","orderdir");
	public $searchin_options=array("title,subtitle","content","title,subtitle,content");
	public $searchin_labels=array("Title &amp; Subtitle","Text","Title, Subtitle &amp; Text");
	public $searchfor_options=array("all_words","any_word","exact_phrase","boolean","regexp");
	public $searchfor_labels=array("All Words","Any Word","Exact Phrase","Boolean Expression","Regular Expression");
	public $return_columns=array();
	public $pagination=null;
	
	function __construct($request){
		
		
		if($request['submit']!=''){
		
			// import search variables
			// and validate form
			
			$err=1;
		
			foreach($this->post_vars as $var){
						
				if($request[$var]!=""){$err=0;}
				
				
				// workaround
				$$var=$request[$var];
				
				//why doesn't this line work??
				$this->$var=$request[$var];
		
			} // end foreach
			
			if($display_page==""){$display_page=1;}
			if($orderby==""){$orderby="title";}
			
			if($search_query==""){$err=1;}
			
			// set the "order by" to the exact table collumn name
			
			$ccc="table_$orderby";
			
			global $$ccc;
			$orderby=$$ccc;
			
			// workaround
			
			$this->search_query=$search_query;
			$this->search_type=$search_type;
			$this->exact_words=$exact_words;
			$this->search_fields=$search_fields;
			$this->display_page=$display_page;
			$this->orderby=$orderby;
			$this->orderdir=$orderdir;
						
			// end workaround

			$this->error_code=$err;			
			// perform search
			
			$this->search();
		
		} // end if
	
	} // end constructor
	

	// search
	//
	// performs the search, and stores the results in the object properties
	public function search(){
	
		require_once("includes/config.php");
		
		global $table_name,$items_per_page;

		// break up the search query into individual keywords.
		$this->explode_search();
		
		// create 'order by' statement
		$order=$this->generate_order(array($this->orderby),array($this->orderdir));
		
		// create array of search columns
		$search_columns=$this->search_columns();//explode(",",$this->search_fields);
		
		// create array of return columns
		$this->return_columns();	
		
		$booleanize=$this->booleanize($this->search_query,$this->search_type);		
		
		// create where clause
		$where=$this->where_clause($booleanize,$search_columns);		
		
		// execute search
		$limit=$this->generate_limit_from_page($this->display_page,$items_per_page);			
		$this->sql_query=$this->generate_query($where,$table_name,$this->return_columns,$limit,$order);			
		$this->results=$this->execute_query($this->sql_query);
		
		// count results 
		$this->results_count=$this->count_results();
				
		// highlight keywords in results
		$this->results=$this->highlight($this->results,$search_columns);	
		
		// make sure we have results
		if(($this->results_count==0)&&($this->error_code==0)){$this->error_code=2;}
		
		// if we have results (and no errors), create the HTML to display them
		if($this->error_code==0){
			
			$this->pagination_display();
			$this->display_results();
		
		}
		
		// handle error message
		
		// empty search
		elseif($this->error_code==1){
		
			$this->results_display="<div class='no_results'>Your search was empty.</div>";
		
		}
		
		// no results
		elseif($this->error_code==2){
		
			$this->results_display="<div class='no_results'>Your search for \"".$this->search_query."\" has produced no results.</div>";
		
		}// end elseif
		
		// unknown error
		elseif($this->error_code>2){
		
			$this->results_display="<div class='error'>An unknown error has occurred.</div>";
		
		}// end elseif
	
	} // end search

	// MOVE!!
	// search columns
	//
	// generates an array of fields to search in
	//
	// parameters
	// searchin - comma deliminated string of fields
	
	protected function search_columns($searchin=''){
	
		global $table_title,$table_subtitle,$table_content,$table_keywords,$table_date,$table_index,$table_identifier;
		
		if($searchin==""){$searchin=$this->search_fields;}
		
		//echo("search_collums");
		
		$recol=explode(",",$searchin);
		
		$sein=array();
		
		foreach($recol as $re){
		
			$name="table_$re";
			$sein[]=$$name;
		
		}
		
		return $sein;
	
	}
	
	// MOVE!!
	// return columns
	//
	// generates an array of table fields
	// from the config file
	//
	// returns
	// col - array of fields
	
	protected function return_columns(){
			
		global $table_title,$table_subtitle,$table_content,$table_keywords,$table_date,$table_index,$table_identifier;

		$col=array($table_title,$table_subtitle,$table_content,$table_keywords,$table_date,$table_index,$table_identifier);
		
		$this->return_columns=$col;
		
		return $col;
	
	} // end return columns


	

	// display results
	//
	// generates HTML to display the search results
	//
	// parameters
	// results - array of search results
	// return
	// html - the html generated
	
	public function display_results($results=null){
	
		global $table_identifier,$table_title,$table_subtitle,$table_date,$content_page,$title_length,$date_format;
		
		if($results==null){$results=$this->results;}
		
		$fe=$this->search_fields;
		
		// determine whether to show highlighted context text.
		// if the search fields include the "content" field, it will 
		// show the highlighted content as part of the display html
		if((strpos($fe,"content")!==false)){$show_text=true;}
		else{$show_text=false;}
		
		$html="";
			
		// parse through the results array
		
		foreach($results as $re){

			// format date
			$dt=explode("-",$re[$table_date]);
			$date=date($date_format,mktime(0,0,0,$dt[1],$dt[2],$dt[0]));
			
			// format the title and subtitle		
			$title_display=$re[$table_title];
			if($re[$table_subtitle]!=""){$title_display.=": ".$re[$table_subtitle];}
			
			$title_display=strip_tags($title_display,"<span>");
			
			// truncating the title, if nessessary
			if(strlen($title_display)>$title_length){
			
				$sp=$title_length;
				while($title_display{$sp}!=" "){$sp-=1;}
				
				$title_display=substr($title_display,0,$sp);//." ...";
				
				// fixing errors caused by truncating off highlighting <span> tag
				
				$len=strlen($title_display);				
				$pp=strrpos($title_display,"<");				
				$dd=strrpos($title_display,"<span>");
				$rr=strrpos($title_display,"</span>");
				
				if($pp!==false){
				
					// if the end tag has been removed
					if(($pp===$dd)){$title_display.="</span>";}
					
					// if the end tag has been truncated
					elseif($pp>($len-10)){$title_display=substr($title_display,0,$pp-1)."</span>";}
				
				} // end if
				
				$title_display.=" ...";
			
			} // end if
						
			if($show_text){$text_display="<br />".$re['text'];}
			else{$text_display="";}
			
			$html.="<div class='item'><a href='$content_page?$table_identifier={$re[$table_identifier]}'>".$title_display;
			
			$html.="</a><div class='date'>$date</div>$text_display</div>
			";
		
		}
		
		//echo($html);
		
		$this->results_display=$html;
		
		return $html;
	
	} // end results display
	
	
	
	// menu searchin
	//
	// create the "search in" dropdown menu
	//
	// parameters
	// selected - the option to be selected
	// return
	// menu - the menu HTML
	
	public function menu_searchin($selected){
	
		return dropdown_menu($this->searchin_labels,$this->searchin_options,$selected);
	
	} // end menu searchin
	
	
	
	// menu searchtype
	//
	// create the "search type" dropdown menu
	//
	// parameters
	// selected - the option to be selected
	// return
	// menu - the menu HTML	
	
	public function menu_searchtype($selected){
	
		return dropdown_menu($this->searchfor_labels,$this->searchfor_options,$selected);		
	
	} // end menu searchtype
	
	
	
	// pagination display
	//
	// generates the HTML for the pagination and sorting
	//
	// return
	// html - the generated HTML code
	
	public function pagination_display(){
		
		global $items_per_page;
		
		$order_array=array("orderby","orderdir","page");
		
		if($this->results_count==null){
		
			$count=$this->count_results();
		
		}// end if
		else{
		
			$count=$this->results_count;
		
		}// end else
		
		$num_pages=ceil($count/$items_per_page);
		
		$page=$this->display_page;
		
		$next_page=$page+1;
		$prev_page=$page-1;
		
		if($prev_page==0){$prev_page=1;}
		if($next_page>$num_pages){$next_page=$num_pages;}
		
		$html="<div class='pagination'>";
		
		// result sorting
		
		$html.="Date ";
		$html.=make_link($order_array,array('date','asc','1','Date Ascending'))."<img src='images/uarr.png' border='0' alt='Date Ascending' /></a>";
		$html.=make_link($order_array,array('date','desc','1','Date Descending'))."<img src='images/darr.png' border='0' alt='Date Descending' /></a> &nbsp;";
		$html.="Title ";
		$html.=make_link($order_array,array('title','asc','1','Title Ascending'))."<img src='images/uarr.png' border='0' alt='Title Ascending' /></a>";
		$html.=make_link($order_array,array('title','desc','1','Title Descending'))."<img src='images/darr.png' border='0' alt='Title Descending' /></a> &nbsp; &nbsp; &nbsp; ";	
		
		// pagination
		
		if($page!=1){$html.=make_link("display_page",$prev_page,"Previous");}
		
		$html.="<img src='images/larr.png' border='0' alt='Previous Page' />";
		
		if($page!=1){$html.="</a>";}
		
		$html.=" &nbsp;";
		
		// generate the list of links to each page
		
		for($i=1;$i<=$num_pages;$i++){
		
			if($page!=$i){$html.=make_link("display_page",$i);}
			
			$html.="$i";
			
			if($page!=$i){$html.="</a>";}
			
			$html.=" ";
		
		} // end for
		
		$html.=" &nbsp;";
				
		if($page!=$next_page){$html.=make_link("display_page",$next_page,"Next");}
		
		$html.="<img src='images/rarr.png' border='0' alt='Next Page' /> ";
		
		if($page!=$next_page){$html.="</a>";}		
		
		
		$html.="</div>";
		
		$this->pagination=$html;
	
	} // end pagination display

} // end class website_search

?>
